RGBImageFilter

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.awt.image
Class RGBImageFilter

    java.lang.Object
      java.awt.image.ImageFilter
          java.awt.image.RGBImageFilter

All Implemented Interfaces:
  ImageConsumer, Cloneable

    public abstract class RGBImageFilter

extends ImageFilter

This class provides an easy way to create an ImageFilter which modifies the pixels of an image in the default RGB ColorModel. It is meant to be used in conjunction with a FilteredImageSource object to produce filtered versions of existing images. It is an abstract class that provides the calls needed to channel all of the pixel data through a single method which converts pixels one at a time in the default RGB ColorModel regardless of the ColorModel being used by the ImageProducer. The only method which needs to be defined to create a useable image filter is the filterRGB method. Here is an example of a definition of a filter which swaps the red and blue components of an image:

            class RedBlueSwapFilter extends RGBImageFilter {
                public RedBlueSwapFilter() {
                    // The filter's operation does not depend on the
                    // pixel's location, so IndexColorModels can be
                    // filtered directly.
                    canFilterIndexColorModel = true;
                }

                public int filterRGB(int x, int y, int rgb) {
                    return ((rgb & 0xff00ff00)
                            | ((rgb & 0xff0000) >> 16)
                            | ((rgb & 0xff) << 16));
                }
            }

Version:
  1.22 01/23/03
Author:
  Jim Graham
See Also:
  `FilteredImageSource`, `ImageFilter`, `ColorModel.getRGBdefault()`

Field Summary

Fields inherited from interface java.awt.image.ImageConsumer
`COMPLETESCANLINES, IMAGEABORTED, IMAGEERROR, RANDOMPIXELORDER, SINGLEFRAME, SINGLEFRAMEDONE, SINGLEPASS, STATICIMAGEDONE, TOPDOWNLEFTRIGHT`

Constructor Summary
`RGBImageFilter()`

Method Summary
`IndexColorModel` | `filterIndexColorModel(IndexColorModel icm)` Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide.
`abstract int` | `filterRGB(int x, int y, int rgb)` Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.
`void` | `filterRGBPixels(int x, int y, int w, int h, int[] pixels, int off, int scansize)` Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.
`void` | `setColorModel(ColorModel model)` If the ColorModel is an IndexColorModel, and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods.
`void` | `setPixels(int x, int y, int w, int h, ColorModel model, byte[] pixels, int off, int scansize)` If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel.
`void` | `setPixels(int x, int y, int w, int h, ColorModel model, int[] pixels, int off, int scansize)` If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.
`void` | `substituteColorModel(ColorModel oldcm, ColorModel newcm)` Registers two ColorModel objects for substitution.

Methods inherited from class java.awt.image.ImageFilter
`clone, getFilterInstance, imageComplete, resendTopDownLeftRight, setDimensions, setHints, setProperties`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### RGBImageFilter

    public RGBImageFilter()

Method Detail

### setColorModel

    public void setColorModel(ColorModel model)

  If the ColorModel is an IndexColorModel, and the subclass has set the canFilterIndexColorModel flag to true, we substitute a filtered version of the color model here and wherever that original ColorModel object appears in the setPixels methods. Otherwise overrides the default ColorModel used by the ImageProducer and specifies the default RGB ColorModel instead.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Specified by:
    `setColorModel` in interface `ImageConsumer`
  Overrides:
    `setColorModel` in class `ImageFilter`
  Parameters:
    `model` - the specified `ColorModel`
  See Also:
    `ImageConsumer`, `ColorModel.getRGBdefault()`

### substituteColorModel

    public void substituteColorModel(ColorModel oldcm,
                                     ColorModel newcm)

  Registers two ColorModel objects for substitution. If the oldcm is encountered during any of the setPixels methods, the newcm is substituted and the pixels passed through untouched (but with the new ColorModel object).

  Parameters:
    `oldcm` - the ColorModel object to be replaced on the fly
    `newcm` - the ColorModel object to replace oldcm on the fly

### filterIndexColorModel

    public IndexColorModel filterIndexColorModel(IndexColorModel icm)

  Filters an IndexColorModel object by running each entry in its color tables through the filterRGB function that RGBImageFilter subclasses must provide. Uses coordinates of -1 to indicate that a color table entry is being filtered rather than an actual pixel value.

  Parameters:
    `icm` - the IndexColorModel object to be filtered
  Returns:
    a new IndexColorModel representing the filtered colors

### filterRGBPixels

    public void filterRGBPixels(int x,
                                int y,
                                int w,
                                int h,
                                int[] pixels,
                                int off,
                                int scansize)

  Filters a buffer of pixels in the default RGB ColorModel by passing them one by one through the filterRGB method.

  Parameters:
    `x, y` - the coordinates of the upper-left corner of the region of pixels
    `w` - the width of the region of pixels
    `h` - the height of the region of pixels
    `pixels` - the array of pixels
    `off` - the offset into the `pixels` array
    `scansize` - the distance from one row of pixels to the next in the array
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGB(int, int, int)`

### setPixels

    public void setPixels(int x,
                          int y,
                          int w,
                          int h,
                          ColorModel model,
                          byte[] pixels,
                          int off,
                          int scansize)

  If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel. Otherwise converts the buffer of byte pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Specified by:
    `setPixels` in interface `ImageConsumer`
  Overrides:
    `setPixels` in class `ImageFilter`
    `w` - the width of the area of pixels
    `h` - the height of the area of pixels
    `model` - the specified `ColorModel`
    `pixels` - the array of pixels
    `off` - the offset into the `pixels` array
    `scansize` - the distance from one row of pixels to the next in the `pixels` array
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

### setPixels

    public void setPixels(int x,
                          int y,
                          int w,
                          int h,
                          ColorModel model,
                          int[] pixels,
                          int off,
                          int scansize)

  If the ColorModel object is the same one that has already been converted, then simply passes the pixels through with the converted ColorModel, otherwise converts the buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method to be converted one by one. Converts a buffer of integer pixels to the default RGB ColorModel and passes the converted buffer to the filterRGBPixels method.

  Note: This method is intended to be called by the `ImageProducer` of the `Image` whose pixels are being filtered. Developers using this class to filter pixels from an image should avoid calling this method directly since that operation could interfere with the filtering operation.

  Specified by:
    `setPixels` in interface `ImageConsumer`
  Overrides:
    `setPixels` in class `ImageFilter`
    `w` - the width of the area of pixels
    `h` - the height of the area of pixels
    `model` - the specified `ColorModel`
    `pixels` - the array of pixels
    `off` - the offset into the `pixels` array
    `scansize` - the distance from one row of pixels to the next in the `pixels` array
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

### filterRGB

    public abstract int filterRGB(int x,
                                  int y,
                                  int rgb)

  Subclasses must specify a method to convert a single input pixel in the default RGB ColorModel to a single output pixel.

  Parameters:
    `x, y` - the coordinates of the pixel
    `rgb` - the integer pixel representation in the default RGB color model
  Returns:
    a filtered pixel in the default RGB color model.
  See Also:
    `ColorModel.getRGBdefault()`, `filterRGBPixels(int, int, int, int, int[], int, int)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD